"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts = __importStar(require("typescript"));
const typescript_ast_util_1 = require("typescript-ast-util");
// TODO: test with jsdoc or a trailing comment
exports.codeFixCreateVariable = {
    name: 'Declare variable',
    config: { variableType: 'const' },
    predicate: (diag, child, log) => {
        if (!diag.find(d => d.code === 2304 || d.code === 2540)) {
            return false;
        }
        if (child.kind === ts.SyntaxKind.BinaryExpression ||
            child.parent && child.parent.kind === ts.SyntaxKind.BinaryExpression ||
            child.parent.parent && child.parent.parent.kind === ts.SyntaxKind.BinaryExpression) {
            return true;
        }
        else {
            log('codeFixCreateVariable predicate false because child.kind dont match ' + typescript_ast_util_1.getKindName(child.kind));
            return false;
        }
    },
    description: (diag, child) => `Declare variable "${child.getText()}"`,
    apply: (diag, child) => {
        child.getSourceFile().insertText(child.getStart(), 'const ');
    }
};
//# sourceMappingURL=codeFixCreateVariable.js.map